<template>
  <article class="view view--identity-account-edit">
    <div class="mb3">
      <router-link :to="profileRoute">View my public profile ({{ username }})</router-link>
    </div>
    <hr />
    <LoadingSpinner v-if="loading" />
    <VForm
      v-if="loaded"
      name="identity-account-edit-form"
      :fields="fields"
      :modelState="modelState"
      buttonText="Save"
      buttonIconClass="bi bi-save-fill"
      :busy="saving"
      busyButtonText="Saving..."
      @submit="onSubmit"
    />
  </article>
</template>

<script>
import { ref, computed, onMounted } from 'vue'
import { useStore } from 'vuex'
import { LoadingSpinner, VForm, useApi, useNotification } from '../../../core'
import AccountApi from '../../api/account-api.js'
import { useAuth } from '../../plugins/auth-plugin.js'
import { useUserAddOn } from '../../plugins/user-add-on-plugin.js'

export default {
  name: 'IdentityAccountEditView',
  components: {
    LoadingSpinner,
    VForm,
  },
  setup() {
    const store = useStore()
    const api = useApi()
    const auth = useAuth()
    const notify = new useNotification()
    const userAddOn = useUserAddOn()
    const accountApi = new AccountApi(api, auth)

    const account = ref(undefined)
    const fields = ref([])
    const modelState = ref({})
    const loading = ref(false)
    const loaded = ref(false)
    const saving = ref(false)

    const username = computed(() => {
      return store.state.identity.session.username
    })

    const profileRoute = computed(() => {
      return username.value ? { name: 'identity-user-profile', params: { username: username.value } } : null
    })

    const onSubmit = async (form) => {
      saving.value = true

      let request = {}
      for (const [key, value] of Object.entries(form)) {
        let addOn = userAddOn.formFields.find((x) => x.field.name === key)
        if (addOn) {
          request = addOn.setter(request, value)
        } else {
          request[key] = value
        }
      }

      try {
        await accountApi.updateAsync(request)
        notify.success('Your account details were saved.')
      } catch (ex) {
        if (ex.response.data?.modelState) {
          modelState.value = ex.response.data.modelState
        } else {
          notify.error('There was a problem saving your account details.', ex)
        }
      } finally {
        saving.value = false
      }
    }

    const loadAsync = async () => {
      loading.value = true
      loaded.value = false
      account.value = null

      try {
        const response = await accountApi.readAsync({ expand: 'image' })
        account.value = response.data
        loaded.value = true
      } catch (ex) {
        notify.error('There was a problem getting your account details.', ex)
      } finally {
        loading.value = false
      }
    }

    onMounted(async () => {
      await loadAsync()
      fields.value = userAddOn.formFields.map((x) => ({ ...x.field, value: x.getter(account.value) }))
    })

    return {
      username,
      account,
      fields,
      modelState,
      loading,
      loaded,
      saving,
      profileRoute,
      onSubmit,
    }
  },
}
</script>
